## AI 프롬프트 실습 9-0: [페이지218]프롬그램 조각을 패턴으로 등록해 재사용하기

## 프롬프트(패턴 등록)
file: ai-예제-패턴-등록하기.md   
```
patterns: 
    LED:
        설명: LED인스턴스를 만듦.
        방법: {{inverted}}가 없으면 False로 지정함.  
        코드: |
            from blink import Blink
            {{이름}} = Blink(pin_instance={{pin_instance}},inverted={{inverted}})
            run.add({{이름}}.run)
    타이머: 
        코드: |
            from timerrun import TimerRun
            {{이름}} = TimerRun(period={{period}},callback={{callback}}) 
            run.add({{이름}}.run)
    앞_부분:
        코드: |
            from machine import Pin
            from run import Run
            import pinno as P

            run = Run()
    뒷_부분:
        코드: |
            def main():
                while True:
                    run.run()

            if __name__ == '__main__':
                main()

```

## 프롬프트(패턴 사용)
file: ai-예제-부품으로-사용하기.md 
```
(여기에 앞에서 작성한 'ai-예제-패턴으로-사용하기.md'의 내용을 붙여 넣으세요)
앞에서 제시된 patterns:을 참조하여 components:를 마이크로파이썬 코드로 만들어 주세요.
components:
- 앞_부분

- LED:
    이름: led_1
    pin_instance: Pin(P.LED_1_IN,Pin.OUT)

def led_toggle():
   led_1.toggle()

components:
- 타이머:
    이름: timer_led
    period: 1*1000
    callback: led_toggle

- 뒷_부분

```
## AI가 만든 코드
프로그램: 7_1.py
```python
from machine import Pin
from run import Run
import pinno as P

run = Run()

from blink import Blink
led_1 = Blink(pin_instance=Pin(P.LED_1_IN, Pin.OUT), inverted=False)
run.add(led_1.run)

def led_toggle():
    led_1.toggle()

from timerrun import TimerRun
timer_led = TimerRun(period=1 * 1000, callback=led_toggle)
run.add(timer_led.run)

def main():
    while True:
        run.run()

if __name__ == '__main__':
    main()

```