## AI 프롬프트 활용 4-6: for문을 while문으로 바꾸기
## 프롬프트 
```
다음 마이크로파이썬 코드를 while 문을 사용해 다시 만들고, 코드를 단계별로 설명해 줘.

for i in range(5):
    if i == 2:
        continue
    print(i)
```
## AI가 만든 결과
아래는 `for` 문을 사용한 기존 코드를 **while** 문으로 변경한 예시입니다. `range(5)`는 0부터 4까지 반복하며, `i == 2`일 때는 `continue`로 출력 없이 다음 반복을 진행합니다.

---

## 변경된 코드 (while 문)

```python
i = 0
while i < 5:
    if i == 2:
        i += 1
        continue
    print(i)
    i += 1
```

---

## 단계별 설명

1. **초기화**  
   ```python
   i = 0
   ```  
   - 반복 제어 변수 `i`를 0으로 시작합니다.

2. **반복 조건**  
   ```python
   while i < 5:
       ...
   ```  
   - `i`가 5보다 작은 동안 반복을 수행합니다. 즉, `i`는 0, 1, 2, 3, 4를 거치게 됩니다.

3. **조건 검사 (`if i == 2`)**  
   ```python
   if i == 2:
       i += 1
       continue
   ```  
   - `i`가 2일 때는 `print()`를 건너뛰어야 합니다.  
   - `i`를 먼저 1 증가시킨 뒤(`i += 1`), `continue`를 실행합니다.  
   - `continue`가 실행되면 **현재 반복의 남은 부분을 건너뛰고** 다음 반복으로 이동합니다.

4. **출력 및 증가**  
   ```python
   print(i)
   i += 1
   ```  
   - `i`가 2가 아닐 경우, `print(i)`로 현재 값을 출력합니다.  
   - 이후 `i`를 1 증가시킵니다.

5. **반복 종료**  
   - `i`가 5가 되는 순간 `while i < 5:` 조건이 거짓(False)이 되어, 반복이 종료됩니다.

---

### 동작 과정 예시

- **i = 0** → `if 0 == 2`: 거짓 → 출력 `0` → `i = 1`  
- **i = 1** → `if 1 == 2`: 거짓 → 출력 `1` → `i = 2`  
- **i = 2** → `if 2 == 2`: 참 → `i = 3`, `continue` → 출력 없이 다음 반복  
- **i = 3** → 출력 `3` → `i = 4`  
- **i = 4** → 출력 `4` → `i = 5`  
- **i = 5** → `while i < 5`는 거짓 → 종료  

결과적으로 `0, 1, 3, 4`가 순서대로 출력됩니다.